Index: main/plugin-web/i18n/messages_en.xml
===================================================================
--- main/plugin-web/i18n/messages_en.xml	(revision 33166)
+++ main/plugin-web/i18n/messages_en.xml	(working copy)
@@ -2400,7 +2400,7 @@
     <message key="PLUGINS_WEB_COOKIES_INFO">By continuing to browse this site, you're accepting the use of cookies to collect anonymous visitor statistics.</message>
     <message key="PLUGINS_WEB_COOKIES_INFO_REFUSE">Refuse</message>
     <message key="PLUGINS_WEB_COOKIES_INFO_ACCEPT">OK</message>
-    <message key="PLUGINS_WEB_SITE_COOKIE_BANNER_LABEL">Enable cookie consent banner</message>
-    <message key="PLUGINS_WEB_SITE_COOKIE_BANNER_DESCRIPTION">Check the box if you want to let the user decide if he allows the use of cookies to collect anonymous visitor statistics. Enabling this could be a legal obligation, depending on the country.</message>
+    <message key="PLUGINS_WEB_SITE_COOKIE_BANNER_LABEL">Always accept cookie</message>
+    <message key="PLUGINS_WEB_SITE_COOKIE_BANNER_DESCRIPTION">Check this box if you want to force the use of cookies to collect anonymous visitor statistics without asking permission to the site visitor. Note that asking for user permission could be a legal obligation, depending on the country.</message>
     <message key="PLUGINS_WEB_SITE_COOKIES_GROUP">Cookies</message>
 </catalogue>
Index: main/plugin-web/i18n/messages_fr.xml
===================================================================
--- main/plugin-web/i18n/messages_fr.xml	(revision 33166)
+++ main/plugin-web/i18n/messages_fr.xml	(working copy)
@@ -2402,8 +2402,8 @@
     <message key="PLUGINS_WEB_COOKIES_INFO">En poursuivant votre navigation sur ce site, vous acceptez l'utilisation de cookies à des fins de mesure d'audience (statistiques anonymes).</message>
     <message key="PLUGINS_WEB_COOKIES_INFO_REFUSE">Refuser</message>
     <message key="PLUGINS_WEB_COOKIES_INFO_ACCEPT">Accepter</message>
-    <message key="PLUGINS_WEB_SITE_COOKIE_BANNER_LABEL">Bandeau d'acceptation des cookies</message>
-    <message key="PLUGINS_WEB_SITE_COOKIE_BANNER_DESCRIPTION">Cochez la case si vous voulez laisser l'utilisateur décider s'il autorise les cookies à des fins de mesure d'audience. Cette fonctionnalité peut être une obligation légale selon les pays.</message>
+    <message key="PLUGINS_WEB_SITE_COOKIE_BANNER_LABEL">Toujours accepter les cookies</message>
+    <message key="PLUGINS_WEB_SITE_COOKIE_BANNER_DESCRIPTION">Cochez la case si vous ne voulez pas laisser l'utilisateur décider s'il autorise les cookies à des fins de mesure d'audience. Cette fonctionnalité peut être une obligation légale selon les pays.</message>
     <message key="PLUGINS_WEB_SITE_COOKIES_GROUP">Cookies</message>
     
 </catalogue>
Index: main/plugin-web/plugin.xml
===================================================================
--- main/plugin-web/plugin.xml	(revision 33166)
+++ main/plugin-web/plugin.xml	(working copy)
@@ -515,7 +515,7 @@
                     <category i18n="true">PLUGINS_WEB_SITE_SERVICES_CATEGORY</category>
                     <group i18n="true">PLUGINS_WEB_SITE_GOOGLE_GROUP</group>
                 </param>
-                <param id="cookie-banner" type="boolean">
+                <param id="force-accept-cookies" type="boolean">
                     <label i18n="true">PLUGINS_WEB_SITE_COOKIE_BANNER_LABEL</label>
                     <description i18n="true">PLUGINS_WEB_SITE_COOKIE_BANNER_DESCRIPTION</description>
                     <category i18n="true">PLUGINS_WEB_SITE_SERVICES_CATEGORY</category>
Index: main/workspace-web/stylesheets/template-default.xsl
===================================================================
--- main/workspace-web/stylesheets/template-default.xsl	(revision 33166)
+++ main/workspace-web/stylesheets/template-default.xsl	(working copy)
@@ -20,6 +20,11 @@
 	xmlns:ametys="org.ametys.web.transformation.xslt.AmetysXSLTHelper"
     extension-element-prefixes="ametys">
 
+    <!-- +
+         | Accept cookies banner
+         + -->  
+    <xsl:variable name="support-cookies-banner">true</xsl:variable>
+
 	<xsl:template name="favico">
         <link rel="icon" type="image/gif" href="{$uri-prefix}/kernel/resources/img/runtime_favico.gif" />
         <link rel="shortcut icon" type="image/x-icon" href="{$uri-prefix}/kernel/resources/img/runtime_favico.ico" />
@@ -115,7 +120,7 @@
         }
         
         <xsl:choose>
-	        <xsl:when test="ametys:siteParameter('cookie-banner')">
+	        <xsl:when test="ametys:siteParameter('force-accept-cookies') = 'false' and $support-cookies-banner = 'true'">
 		        ametysClickprocessed = false;
 		        ametysCookieExpireDay = 390;
 		        
@@ -124,21 +129,24 @@
 			        // Show the information banner to the top of the page
 			        function showBanner()
 			        {
-			           var html = '&lt;div class="cookiebanner" id="cookie-banner">';
-			           html += '&lt;div class="info-cookies" id="cookie-banner-message">';
-			           html += "<i18n:text i18n:key='PLUGINS_WEB_COOKIES_INFO' i18n:catalogue='plugin.web'/>";
-			           html += ' ';
-			           html += '&lt;a href="javascript:ametysAcceptCookieConsent()">';
-			           html += "<i18n:text i18n:key='PLUGINS_WEB_COOKIES_INFO_ACCEPT' i18n:catalogue='plugin.web'/>";
-			           html += '&lt;/a>';
-			           html += ' ';
-			           html += '&lt;a href="javascript:ametysRefuseCookieConsent()">';
-			           html += "<i18n:text i18n:key='PLUGINS_WEB_COOKIES_INFO_REFUSE' i18n:catalogue='plugin.web'/>";
-			           html += '&lt;/a>';
-			           html += '&lt;/div>';
-			           html += '&lt;/div>';
-			
-			           $j(document.body).prepend(html).addClass('cookiebanner-visible');
+			           if (ametysCookieConsentListener.length != 0)
+			           {
+				           var html = '&lt;div class="cookiebanner" id="cookie-banner">';
+				           html += '&lt;div class="info-cookies" id="cookie-banner-message">';
+				           html += "<i18n:text i18n:key='PLUGINS_WEB_COOKIES_INFO' i18n:catalogue='plugin.web'/>";
+				           html += ' ';
+				           html += '&lt;a href="javascript:ametysAcceptCookieConsent()">';
+				           html += "<i18n:text i18n:key='PLUGINS_WEB_COOKIES_INFO_ACCEPT' i18n:catalogue='plugin.web'/>";
+				           html += '&lt;/a>';
+				           html += ' ';
+				           html += '&lt;a href="javascript:ametysRefuseCookieConsent()">';
+				           html += "<i18n:text i18n:key='PLUGINS_WEB_COOKIES_INFO_REFUSE' i18n:catalogue='plugin.web'/>";
+				           html += '&lt;/a>';
+				           html += '&lt;/div>';
+				           html += '&lt;/div>';
+				
+				           $j(document.body).prepend(html).addClass('cookiebanner-visible');
+			           }
 			        }
 			    
 			        // Get the Internet Explorer version, return -1 if not IE